/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef MONOTONE_PROCESS_H
#define MONOTONE_PROCESS_H

#include "MonotoneResourceFile.h"

#include <QProcess>
#include <QStringList>

class MonotoneProcess : public QProcess
{
    Q_OBJECT
public:
    MonotoneProcess(const QString & workdir = QString());
    virtual ~MonotoneProcess();

    void start(const QStringList &);
    QString getBufferedOutput() const;

    void setMtnBinaryPath(const QString &);

    bool successful();

    static bool singleRun(const QStringList & params, const QString &, QString & output);

signals:
    void output(const QString &);
    void error(const QString &);

private slots:
    void readOutput();
    void processError(QProcess::ProcessError);

private:
    QString mtnBinaryPath;
    QString bufferedOutput;
    MonotoneResourceFile rcFile;
};

#endif
